if (NOT EXT_LIBS)
	message(FATALL_ERROR "Variable EXT_LIBS is empty. It should point to directory, where glib, intl, zlib and kticonv are installed")
endif()

set (COMM_EXT_LIB "${EXT_LIBS}/lib")
set (COMM_EXT_BIN "${EXT_LIBS}/bin")

include_directories("${EXT_LIBS}/include")

if (WIN32)
	add_library(z        STATIC IMPORTED) 
	set_property(TARGET z APPEND PROPERTY IMPORTED_CONFIGURATIONS RELWITHDEBINFO)
	set_target_properties(z PROPERTIES
	     IMPORTED_LOCATION_RELWITHDEBINFO "${COMM_EXT_LIB}/zlib.lib"
	)
	set_property(TARGET z APPEND PROPERTY IMPORTED_CONFIGURATIONS DEBUG)
	set_target_properties(z PROPERTIES
    	 IMPORTED_LOCATION_DEBUG "${COMM_EXT_LIB}/zlib.lib"
	)

	add_library(kticonv   SHARED IMPORTED)
	set_property(TARGET kticonv   APPEND PROPERTY IMPORTED_CONFIGURATIONS RELWITHDEBINFO)
	set_property(TARGET kticonv   APPEND PROPERTY IMPORTED_CONFIGURATIONS DEBUG)
	set_target_properties(kticonv PROPERTIES
		 IMPORTED_IMPLIB_DEBUG            "${COMM_EXT_LIB}/iconv_d.lib"
		 IMPORTED_IMPLIB_RELWITHDEBINFO   "${COMM_EXT_LIB}/iconv.lib"
		 IMPORTED_LOCATION_DEBUG          "${COMM_EXT_BIN}/kticonv80_1.11.1_d.dll"
		 IMPORTED_LOCATION_RELWITHDEBINFO "${COMM_EXT_BIN}/kticonv80_1.11.1.dll"
	)

	add_library(glib    SHARED IMPORTED)
	set_property(TARGET glib    APPEND PROPERTY IMPORTED_CONFIGURATIONS RELWITHDEBINFO)
	set_property(TARGET glib    APPEND PROPERTY IMPORTED_CONFIGURATIONS DEBUG)
	set_target_properties(glib PROPERTIES
		 IMPORTED_IMPLIB_DEBUG            "${COMM_EXT_LIB}/glib-2.0_d.lib"
		 IMPORTED_IMPLIB_RELWITHDEBINFO   "${COMM_EXT_LIB}/glib-2.0.lib"
		 IMPORTED_LOCATION_DEBUG          "${COMM_EXT_BIN}/glib-2.0_d.dll"
		 IMPORTED_LOCATION_RELWITHDEBINFO "${COMM_EXT_BIN}/glib-2.0.dll"
	)

	add_library(gmodule SHARED IMPORTED)
	set_property(TARGET gmodule APPEND PROPERTY IMPORTED_CONFIGURATIONS RELWITHDEBINFO)
	set_property(TARGET gmodule APPEND PROPERTY IMPORTED_CONFIGURATIONS DEBUG)
	set_target_properties(gmodule PROPERTIES
		 IMPORTED_IMPLIB_DEBUG            "${COMM_EXT_LIB}/gmodule-2.0_d.lib"
		 IMPORTED_IMPLIB_RELWITHDEBINFO   "${COMM_EXT_LIB}/gmodule-2.0.lib"
		 IMPORTED_LOCATION_DEBUG          "${COMM_EXT_BIN}/gmodule-2.0_d.dll"
		 IMPORTED_LOCATION_RELWITHDEBINFO "${COMM_EXT_BIN}/gmodule-2.0.dll"
		 IMPORTED_LINK_INTERFACE_LIBRARIES_RELWITHDEBINFO "glib"
		 IMPORTED_LINK_INTERFACE_LIBRARIES_DEBUG "glib"
	)

	add_library(gthread SHARED IMPORTED)
	set_property(TARGET gthread APPEND PROPERTY IMPORTED_CONFIGURATIONS RELWITHDEBINFO)
	set_property(TARGET gthread APPEND PROPERTY IMPORTED_CONFIGURATIONS DEBUG)
	set_target_properties(gthread PROPERTIES
		 IMPORTED_IMPLIB_DEBUG            "${COMM_EXT_LIB}/gthread-2.0_d.lib"
		 IMPORTED_IMPLIB_RELWITHDEBINFO   "${COMM_EXT_LIB}/gthread-2.0.lib"
		 IMPORTED_LOCATION_DEBUG          "${COMM_EXT_BIN}/gthread-2.0_d.dll"
		 IMPORTED_LOCATION_RELWITHDEBINFO "${COMM_EXT_BIN}/gthread-2.0.dll"
		 IMPORTED_LINK_INTERFACE_LIBRARIES_RELWITHDEBINFO "glib"
		 IMPORTED_LINK_INTERFACE_LIBRARIES_DEBUG "glib"
	)

	add_library(gobject SHARED IMPORTED)
	set_property(TARGET gobject APPEND PROPERTY IMPORTED_CONFIGURATIONS RELWITHDEBINFO)
	set_property(TARGET gobject APPEND PROPERTY IMPORTED_CONFIGURATIONS DEBUG)
	set_target_properties(gobject PROPERTIES
		 IMPORTED_IMPLIB_DEBUG            "${COMM_EXT_LIB}/gobject-2.0_d.lib"
		 IMPORTED_IMPLIB_RELWITHDEBINFO   "${COMM_EXT_LIB}/gobject-2.0.lib"
		 IMPORTED_LOCATION_DEBUG          "${COMM_EXT_BIN}/gobject-2.0_d.dll"
		 IMPORTED_LOCATION_RELWITHDEBINFO "${COMM_EXT_BIN}/gobject-2.0.dll"
		 IMPORTED_LINK_INTERFACE_LIBRARIES_RELWITHDEBINFO "glib;gthread"
		 IMPORTED_LINK_INTERFACE_LIBRARIES_DEBUG "glib;gthread"
	)

	add_library(gio     SHARED IMPORTED)
	set_property(TARGET gio     APPEND PROPERTY IMPORTED_CONFIGURATIONS RELWITHDEBINFO)
	set_property(TARGET gio     APPEND PROPERTY IMPORTED_CONFIGURATIONS DEBUG)
	set_target_properties(gio PROPERTIES
		 IMPORTED_IMPLIB_DEBUG            "${COMM_EXT_LIB}/gio-2.0_d.lib"
		 IMPORTED_IMPLIB_RELWITHDEBINFO   "${COMM_EXT_LIB}/gio-2.0.lib"
		 IMPORTED_LOCATION_DEBUG          "${COMM_EXT_BIN}/gio-2.0_d.dll"
		 IMPORTED_LOCATION_RELWITHDEBINFO "${COMM_EXT_BIN}/gio-2.0.dll"
		 IMPORTED_LINK_INTERFACE_LIBRARIES_RELWITHDEBINFO "glib;gmodule;gobject"
		 IMPORTED_LINK_INTERFACE_LIBRARIES_DEBUG "glib;gmodule;gobject"
	)
elseif("${CMAKE_SYSTEM_NAME}" MATCHES "Linux")
	add_library(kticonv   SHARED IMPORTED)
	set_property(TARGET kticonv   APPEND PROPERTY IMPORTED_CONFIGURATIONS RELWITHDEBINFO)
	set_property(TARGET kticonv   APPEND PROPERTY IMPORTED_CONFIGURATIONS DEBUG)
	set_target_properties(kticonv PROPERTIES
		 IMPORTED_IMPLIB_DEBUG            "${COMM_EXT_LIB}/kticonv_1.11.1.so"
		 IMPORTED_IMPLIB_RELWITHDEBINFO   "${COMM_EXT_LIB}/kticonv_1.11.1.so"
		 IMPORTED_LOCATION_DEBUG          "${COMM_EXT_BIN}/kticonv_1.11.1.so"
		 IMPORTED_LOCATION_RELWITHDEBINFO "${COMM_EXT_BIN}/kticonv_1.11.1.so"
	)

	add_library(glib    STATIC IMPORTED)
	set_property(TARGET glib    APPEND PROPERTY IMPORTED_CONFIGURATIONS RELWITHDEBINFO)
	set_property(TARGET glib    APPEND PROPERTY IMPORTED_CONFIGURATIONS DEBUG)
	set_target_properties(glib PROPERTIES
		 IMPORTED_LOCATION_DEBUG          "${COMM_EXT_LIB}/libglib-2.0.a"
		 IMPORTED_LOCATION_RELWITHDEBINFO "${COMM_EXT_LIB}/libglib-2.0.a"
	)

	add_library(gmodule STATIC IMPORTED)
	set_property(TARGET gmodule APPEND PROPERTY IMPORTED_CONFIGURATIONS RELWITHDEBINFO)
	set_property(TARGET gmodule APPEND PROPERTY IMPORTED_CONFIGURATIONS DEBUG)
	set_target_properties(gmodule PROPERTIES
		 IMPORTED_LOCATION_DEBUG          "${COMM_EXT_LIB}/libgmodule-2.0.a"
		 IMPORTED_LOCATION_RELWITHDEBINFO "${COMM_EXT_LIB}/libgmodule-2.0.a"
		 IMPORTED_LINK_INTERFACE_LIBRARIES_RELWITHDEBINFO "glib"
		 IMPORTED_LINK_INTERFACE_LIBRARIES_DEBUG "glib"
	)

	add_library(gthread STATIC IMPORTED)
	set_property(TARGET gthread APPEND PROPERTY IMPORTED_CONFIGURATIONS RELWITHDEBINFO)
	set_property(TARGET gthread APPEND PROPERTY IMPORTED_CONFIGURATIONS DEBUG)
	set_target_properties(gthread PROPERTIES
		 IMPORTED_LOCATION_DEBUG          "${COMM_EXT_LIB}/libgthread-2.0.a"
		 IMPORTED_LOCATION_RELWITHDEBINFO "${COMM_EXT_LIB}/libgthread-2.0.a"
		 IMPORTED_LINK_INTERFACE_LIBRARIES_RELWITHDEBINFO "glib"
		 IMPORTED_LINK_INTERFACE_LIBRARIES_DEBUG "glib"
	)

	add_library(gobject STATIC IMPORTED)
	set_property(TARGET gobject APPEND PROPERTY IMPORTED_CONFIGURATIONS RELWITHDEBINFO)
	set_property(TARGET gobject APPEND PROPERTY IMPORTED_CONFIGURATIONS DEBUG)
	set_target_properties(gobject PROPERTIES
		 IMPORTED_LOCATION_DEBUG          "${COMM_EXT_LIB}/libgobject-2.0.a"
		 IMPORTED_LOCATION_RELWITHDEBINFO "${COMM_EXT_LIB}/libgobject-2.0.a"
		 IMPORTED_LINK_INTERFACE_LIBRARIES_RELWITHDEBINFO "glib;gthread"
		 IMPORTED_LINK_INTERFACE_LIBRARIES_DEBUG "glib;gthread"
	)

	add_library(gio     STATIC IMPORTED)
	set_property(TARGET gio     APPEND PROPERTY IMPORTED_CONFIGURATIONS RELWITHDEBINFO)
	set_property(TARGET gio     APPEND PROPERTY IMPORTED_CONFIGURATIONS DEBUG)
	set_target_properties(gio PROPERTIES
		 IMPORTED_LOCATION_DEBUG          "${COMM_EXT_LIB}/libgio-2.0.a"
		 IMPORTED_LOCATION_RELWITHDEBINFO "${COMM_EXT_LIB}/libgio-2.0.a"
		 IMPORTED_LINK_INTERFACE_LIBRARIES_RELWITHDEBINFO "glib;gmodule;gobject"
		 IMPORTED_LINK_INTERFACE_LIBRARIES_DEBUG "glib;gmodule;gobject"
	)
elseif(APPLE)
	add_library(kticonv   SHARED IMPORTED)
	set_property(TARGET kticonv   APPEND PROPERTY IMPORTED_CONFIGURATIONS RELWITHDEBINFO)
	set_property(TARGET kticonv   APPEND PROPERTY IMPORTED_CONFIGURATIONS DEBUG)
	set_target_properties(kticonv PROPERTIES
		 IMPORTED_IMPLIB_DEBUG            "${COMM_EXT_BIN}/kticonv_1.11.1.dylib"
		 IMPORTED_IMPLIB_RELWITHDEBINFO   "${COMM_EXT_BIN}/kticonv_1.11.1.dylib"
		 IMPORTED_LOCATION_DEBUG          "${COMM_EXT_BIN}/kticonv_1.11.1.dylib"
		 IMPORTED_LOCATION_RELWITHDEBINFO "${COMM_EXT_BIN}/kticonv_1.11.1.dylib"
	)

	add_library(intl STATIC IMPORTED)
	set_property(TARGET intl APPEND PROPERTY IMPORTED_CONFIGURATIONS RELWITHDEBINFO)
	set_property(TARGET intl APPEND PROPERTY IMPORTED_CONFIGURATIONS DEBUG)
	set_target_properties(intl PROPERTIES
		 IMPORTED_LOCATION_DEBUG          "${COMM_EXT_LIB}/libintl.a"
		 IMPORTED_LOCATION_RELWITHDEBINFO "${COMM_EXT_LIB}/libintl.a"
		 IMPORTED_LINK_INTERFACE_LIBRARIES_DEBUG "iconv"
		 IMPORTED_LINK_INTERFACE_LIBRARIES_RELWITHDEBINFO "iconv"
	)

	add_library(glib    STATIC IMPORTED)
	set_property(TARGET glib    APPEND PROPERTY IMPORTED_CONFIGURATIONS RELWITHDEBINFO)
	set_property(TARGET glib    APPEND PROPERTY IMPORTED_CONFIGURATIONS DEBUG)
	set_target_properties(glib PROPERTIES
		 IMPORTED_LOCATION_DEBUG          "${COMM_EXT_LIB}/libglib-2.0.a"
		 IMPORTED_LOCATION_RELWITHDEBINFO "${COMM_EXT_LIB}/libglib-2.0.a"
		 IMPORTED_LINK_INTERFACE_LIBRARIES_DEBUG "-framework Carbon;intl"
		 IMPORTED_LINK_INTERFACE_LIBRARIES_RELWITHDEBINFO "-framework Carbon;intl"
	)

	add_library(gmodule STATIC IMPORTED)
	set_property(TARGET gmodule APPEND PROPERTY IMPORTED_CONFIGURATIONS RELWITHDEBINFO)
	set_property(TARGET gmodule APPEND PROPERTY IMPORTED_CONFIGURATIONS DEBUG)
	set_target_properties(gmodule PROPERTIES
		 IMPORTED_LOCATION_DEBUG          "${COMM_EXT_LIB}/libgmodule-2.0.a"
		 IMPORTED_LOCATION_RELWITHDEBINFO "${COMM_EXT_LIB}/libgmodule-2.0.a"
		 IMPORTED_LINK_INTERFACE_LIBRARIES_RELWITHDEBINFO "glib"
		 IMPORTED_LINK_INTERFACE_LIBRARIES_DEBUG "glib"
	)

	add_library(gthread STATIC IMPORTED)
	set_property(TARGET gthread APPEND PROPERTY IMPORTED_CONFIGURATIONS RELWITHDEBINFO)
	set_property(TARGET gthread APPEND PROPERTY IMPORTED_CONFIGURATIONS DEBUG)
	set_target_properties(gthread PROPERTIES
		 IMPORTED_LOCATION_DEBUG          "${COMM_EXT_LIB}/libgthread-2.0.a"
		 IMPORTED_LOCATION_RELWITHDEBINFO "${COMM_EXT_LIB}/libgthread-2.0.a"
		 IMPORTED_LINK_INTERFACE_LIBRARIES_RELWITHDEBINFO "glib"
		 IMPORTED_LINK_INTERFACE_LIBRARIES_DEBUG "glib"
	)

	add_library(gobject STATIC IMPORTED)
	set_property(TARGET gobject APPEND PROPERTY IMPORTED_CONFIGURATIONS RELWITHDEBINFO)
	set_property(TARGET gobject APPEND PROPERTY IMPORTED_CONFIGURATIONS DEBUG)
	set_target_properties(gobject PROPERTIES
		 IMPORTED_LOCATION_DEBUG          "${COMM_EXT_LIB}/libgobject-2.0.a"
		 IMPORTED_LOCATION_RELWITHDEBINFO "${COMM_EXT_LIB}/libgobject-2.0.a"
		 IMPORTED_LINK_INTERFACE_LIBRARIES_RELWITHDEBINFO "glib;gthread"
		 IMPORTED_LINK_INTERFACE_LIBRARIES_DEBUG "glib;gthread"
	)

	add_library(gio     STATIC IMPORTED)
	set_property(TARGET gio     APPEND PROPERTY IMPORTED_CONFIGURATIONS RELWITHDEBINFO)
	set_property(TARGET gio     APPEND PROPERTY IMPORTED_CONFIGURATIONS DEBUG)
	set_target_properties(gio PROPERTIES
		 IMPORTED_LOCATION_DEBUG          "${COMM_EXT_LIB}/libgio-2.0.a"
		 IMPORTED_LOCATION_RELWITHDEBINFO "${COMM_EXT_LIB}/libgio-2.0.a"
		 IMPORTED_LINK_INTERFACE_LIBRARIES_RELWITHDEBINFO "glib;gmodule;gobject"
		 IMPORTED_LINK_INTERFACE_LIBRARIES_DEBUG "glib;gmodule;gobject"
	)
endif()
